//PrinterForge - instructables

// please feel free to ask for any changes to the code or problems to solve :D

#include <IBusBM.h>

IBusBM IBus;     // Create IBus object

// Define pins for Motor A
int motor_IN1 = 2;
int motor_IN2 = 3;
int motor_ENA = 9; // Enable pin for Motor A
int motor_speed = 0; // Variable to store motor speed

void setup() {
  // Set pins as outputs
  pinMode(motor_IN1, OUTPUT);
  pinMode(motor_IN2, OUTPUT);
  pinMode(motor_ENA, OUTPUT);

  // Initialize serial communication
  Serial.begin(115200);
  
  // Initialize IBus with Serial0
  IBus.begin(Serial);
}

void loop() {
  // Read channel values
  int CH2 = IBus.readChannel(1); // Assuming CH2 is the "drive stick" for motor control
  int CH3 = IBus.readChannel(2); // Assuming CH3 is the "accelerator stick" for motor speed

  // Calculate motor speed based on CH3 values
  int pwm = map(CH3, 1014, 1990, 0, 255);

  // Ensure pwm stays within the 0-255 rang
  pwm = constrain(pwm, 0, 255);

  // Determine motor direction based on CH2 position
  if (CH2 > 1000 && CH2 < 1339) {
    // Move the motor backward
    digitalWrite(motor_IN1, HIGH);
    digitalWrite(motor_IN2, LOW);
  } else if (CH2 >= 1339 && CH2 < 1664) {
    // Stop the motor
    digitalWrite(motor_IN1, LOW);
    digitalWrite(motor_IN2, LOW);
  } else if (CH2 >= 1664 && CH2 < 1990) {
    // Move the motor forward
    digitalWrite(motor_IN1, LOW);
    digitalWrite(motor_IN2, HIGH);
  }

  // Set motor speed using PWM
  analogWrite(motor_ENA, pwm);

  // Print motor direction and PWM to serial monitor
  /*Serial.print("CH3: ");
  Serial.print(CH3);
  Serial.print(" pwm = ");
  Serial.print(pwm);
  Serial.print(", CH2: ");
  Serial.print(CH2);
  Serial.print(" Motor Direction: ");
  if (CH2 > 1000 && CH2 < 1339) {
    Serial.println("Backward");
  } else if (CH2 >= 1339 && CH2 < 1664) {
    Serial.println("Stopped");
  } else if (CH2 >= 1664 && CH2 < 1990) {
    Serial.println("Forward");
  }
  */
  delay(10); // Adjust delay as needed to prevent serial output overflow
}
